<template>
  <div class="container mx-auto px-4 max-w-2xl mt-4">
    <div class="flex items-center justify-between">
      <router-link
        :to="{ name: 'ChapterList' }"
        class="text-blue-600 hover:text-blue-800"
      >
        &lt; Back to list
      </router-link>

      <div>
        <router-link
          v-if="item"
          :to="{ name: 'ChapterUpdate', params: { id: item['@id'] } }"
          class="px-6 py-2 mr-2 bg-green-600 text-white text-xs rounded shadow-md hover:bg-green-700"
        >
          Edit
        </router-link>
        <button
          class="px-6 py-2 bg-red-600 text-white text-xs rounded shadow-md hover:bg-red-700"
          @click="deleteItem"
        >
          Delete
        </button>
      </div>
    </div>

    <h1 class="text-3xl my-4">Show Chapter {{ item?.["@id"] }}</h1>

    <div
      v-if="isLoading"
      class="bg-blue-100 rounded py-4 px-4 text-blue-700 text-sm"
      role="status"
    >
      Loading...
    </div>

    <div
      v-if="error || deleteError"
      class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      role="alert"
    >
      {{ error || deleteError }}
    </div>

    <div v-if="item" class="overflow-x-auto">
      <table class="min-w-full">
        <thead class="border-b">
          <tr>
            <th scope="col" class="text-sm font-medium px-6 py-4 text-left">
              Field
            </th>
            <th scope="col" class="text-sm font-medium px-6 py-4 text-left">
              Value
            </th>
          </tr>
        </thead>
        <tbody>
          <tr class="border-b">
            <th
              class="text-sm font-medium px-6 py-4 text-left capitalize"
              scope="row"
            >
              number
            </th>
            <td class="px-6 py-4 whitespace-nowrap text-sm">
            {{ item.number }}
                        </td>
          </tr>
          <tr class="border-b">
            <th
              class="text-sm font-medium px-6 py-4 text-left capitalize"
              scope="row"
            >
              date
            </th>
            <td class="px-6 py-4 whitespace-nowrap text-sm">
            {{ formatDateTime(item.date) }}
            </td>
          </tr>
          <tr class="border-b">
            <th
              class="text-sm font-medium px-6 py-4 text-left capitalize"
              scope="row"
            >
              book
            </th>
            <td class="px-6 py-4 whitespace-nowrap text-sm">
            <router-link
              v-if="router.hasRoute('BookShow')"
              :to="{ name: 'BookShow', params: { id: item.book } }"
              class="text-blue-600 hover:text-blue-800"
            >
              {{ item.book }}
            </router-link>

            <p v-else>
              {{ item.book }}
            </p>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { onBeforeUnmount } from "vue";
import { useRoute, useRouter } from "vue-router";
import { storeToRefs } from "pinia";
import { useChapterShowStore } from "@/stores/chapter/show";
import { useChapterDeleteStore } from "@/stores/chapter/delete";
import { formatDateTime } from "@/utils/date";
import { useMercureItem } from "@/composables/mercureItem";

const route = useRoute();
const router = useRouter();

const chapterDeleteStore = useChapterDeleteStore();
const { error: deleteError, deleted } = storeToRefs(chapterDeleteStore);

const chapterShowStore = useChapterShowStore();
const { retrieved: item, isLoading, error } = storeToRefs(chapterShowStore);

useMercureItem({
  store: chapterShowStore,
  deleteStore: chapterDeleteStore,
  redirectRouteName: "ChapterList",
});

await chapterShowStore.retrieve(decodeURIComponent(route.params.id as string));

async function deleteItem() {
  if (!item?.value) {
    chapterDeleteStore.setError("This item does not exist anymore");
    return;
  }

  if (window.confirm("Are you sure you want to delete this chapter?")) {
    await chapterDeleteStore.deleteItem(item.value);

    if (deleted) {
      router.push({ name: "ChapterList" });
    }
  }
}

onBeforeUnmount(() => {
  chapterShowStore.$reset();
});
</script>

